
-- $Id: 1.3.sql,v 1.9 2008/03/06 16:45:32 rodney Exp $

ALTER TABLE aliases ADD ctime TIMESTAMP NOT NULL DEFAULT NOW();
ALTER TABLE aliases ADD mtime TIMESTAMP NOT NULL DEFAULT NOW();

CREATE OR REPLACE FUNCTION mtime_change() RETURNS TRIGGER AS '
BEGIN
  NEW.mtime := ''now()''; -- Remember change time
  RETURN NEW;
END;
' LANGUAGE 'plpgsql';


CREATE TRIGGER aliases_change01 BEFORE UPDATE OR
 INSERT ON aliases
    FOR EACH ROW EXECUTE PROCEDURE mtime_change();


ALTER TABLE users ADD ctime TIMESTAMP NOT NULL DEFAULT NOW();
ALTER TABLE users ADD mtime TIMESTAMP NOT NULL DEFAULT NOW();
ALTER TABLE users ADD ag NUMERIC(10) DEFAULT 1 NOT NULL REFERENCES ag (id);


CREATE TRIGGER users_change01 BEFORE UPDATE OR
 INSERT ON users
    FOR EACH ROW EXECUTE PROCEDURE mtime_change();


CREATE OR REPLACE VIEW virtdom AS
SELECT DISTINCT SUBSTRING(login FROM '@(.*)') AS domain
  FROM (SELECT login FROM users UNION ALL SELECT adr FROM aliases) q1;



INSERT INTO ag (id,name) VALUES (1,'default');
INSERT INTO users (login,pass,id) VALUES ('admin@localhost','changeme',1);
INSERT INTO admin (usr,ag) VALUES (1,1);
INSERT INTO agdomain (domain,ag) VALUES ('localhost',1);


ALTER TABLE aliases DROP CONSTRAINT aliases_pkey;
ALTER TABLE aliases ADD PRIMARY KEY (adr,dst);


UPDATE meta SET val = '1.4' WHERE tag = 'dbversion';

COMMIT;
